Subject: Re: [PATCH 2/2] firmware: imx: sm-misc: Print boot/shutdown reasons

From: Peng Fan <[email-masked]>
Date: Tue, 10 Mar 2026 13:10:04 +0800

On Thu, Mar 05, 2026 at 11:48:31AM +0100, Oleksij Rempel wrote:
>Hi all,
>
>On Thu, Mar 05, 2026 at 06:22:15PM +0800, Peng Fan wrote:
>> Hi Alexander,
>>
>> Thanks for giving a look.
>>
>> On Thu, Mar 05, 2026 at 08:44:26AM +0100, Alexander Stein wrote:
>> >Hi,
>> >
>> >Am Donnerstag, 5. März 2026, 02:56:45 CET schrieb Peng Fan (OSS):
>> >> From: Peng Fan <[email-masked]>
>> >>
>> >> Add reset reason string table for i.MX95 and introduce a helper
>> >> (scmi_imx_misc_get_reason) to query and print both system and LM
>> >> (Logical Machine) reset reasons via the SCMI MISC protocol.
>> >>
>> >> Signed-off-by: Peng Fan <[email-masked]>
>> >> ---
>> [...]
>> >> +		if (boot.valid)
>> >> +			dev_info(&sdev->dev, "%s Boot reason: %s, origin: %d, errid: %d\n",
>> >> +				 system ? "SYS" : "LM", rst[boot.reason],
>> >> +				 boot.orig_valid ? boot.origin : -1,
>> >> +				 boot.err_valid ? boot.errid : -1);
>> >> +		if (shutdown.valid)
>> >> +			dev_info(&sdev->dev, "%s shutdown reason: %s, origin: %d, errid: %d\n",
>> >> +				 system ? "SYS" : "LM", rst[shutdown.reason],
>> >> +				 shutdown.orig_valid ? shutdown.origin : -1,
>> >> +				 shutdown.err_valid ? shutdown.errid : -1);
>> >
>> >Is there a way to query this from userspace programs instead of printing into kernel log?
>>
>> I not add sysfs or debugfs to get the information in this patchset, since our
>> customer only want the information could be shown in kernel boot log.
>>
>> But I could add also sysfs interface to allow userspace get the information if
>> you need this feature.
>
>I started to working on corresponding framework:
>https://lore.kernel.org/all/[email-masked]/

Thanks for sharing the thread.

>
>but it is stalled due to devicetree decisions. I wont to respin the
>discussion tomorrow

TBH, I have not look into the details. If the generic framework could land
into linux kernel, we could use this in i.MX SCMI reset reason. But I would
not add dependency for now, so I will still just keep printing the log into
kernel log.

Thanks,
Peng

>Best Regards,
>Oleksij